package ru.dbotthepony.mc.otm

import net.minecraftforge.common.ForgeConfigSpec
import net.minecraftforge.fml.ModLoadingContext
import net.minecraftforge.fml.config.ModConfig

object ClientConfig {
	private val specBuilder = ForgeConfigSpec.Builder()
	@Suppress("JoinDeclarationAndAssignment")
	private val spec: ForgeConfigSpec
	private var registered = false

	var EXOPACK_INVENTORY_ROWS: Int by specBuilder
		.comment("Amount of inventory rows to show when wearing Exosuit")
		.defineInRange("exosuitInventoryRows", 3, 3, 6)

	var JUMP_BOOST_LOOK_ANGLE: Double by specBuilder
		.comment("If looking below this angle (actually, looking 'above' as you see in game, but not as you expect it, check with debug screen), Crouch + Jump will trigger jump boost android ability")
		.defineInRange("jumpBoostTriggerAngle", 30.0, -180.0, 180.0)

	var EXOPACK_FREE_SCROLL: Boolean by specBuilder
		.comment("Allow to scroll Exopack inventory in non OTM inventories when hovering just over inventory slots, not only scrollbar")
		.define("exopackFreeScroll", true)

	init {
		spec = specBuilder.build()
	}

	fun register() {
		check(!registered) { "Already registered config" }
		registered = true
		ModLoadingContext.get().registerConfig(ModConfig.Type.CLIENT, spec)
	}
}
